#include "testlib.h"

using namespace std;

typedef long long ll;

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);
    int n = opt<int>("n"), mode = opt<int>("mode");
    ll a = has_opt("a") ? opt<ll>("a") : 1000'000'000'000;

    vector<pair<ll, ll>> rects;
    ll x = rnd.wnext(a / 2, a, 1), y = rnd.wnext(1ll, a / 2, -1);
    while (x > 0 && y > 0) {
        if (x > y) swap(x, y);
        rects.emplace_back(x, x);
        y -= x;
    }
    reverse(rects.begin(), rects.end());
    if (mode == 0) {
        rects.back().first = rnd.next(1ll, a);
        rects.back().second = rects.back().first;
    }

    while (rects.size() > n) {
        rects.pop_back();
    }
    while (rects.size() < n) {
        rects.push_back(rects.back());
    }
    println(rects.size());
    for (auto &rect : rects) {
        if (rnd.next(2)) swap(rect.first, rect.second);
        println(rect.first, rect.second);
    }

}