#include "testlib.h"

using namespace std;

typedef long long ll;

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);
    int n = opt<int>("n"), mode = opt<int>("mode"), da = has_opt("da") ? opt<int>("da") : 39;

    vector<pair<ll, ll>> rects;
    ll x = 1ll << rnd.next(2, da);
    ll y = 1ll << rnd.next(2, da);
    while (x > 1 || y > 1) {
        if (rnd.next(2)) swap(x, y);
        if (x == 1) swap(x, y);
        rects.emplace_back(x / 2, y);
        x /= 2;
    }
    rects.emplace_back(x, y);
    reverse(rects.begin(), rects.end());
    if (mode == 0) {
        rects.back().first = 1ll << rnd.next(1, da);
        rects.back().second = 1ll << rnd.next(1, da);
    }

    while (rects.size() > n) {
        rects.pop_back();
    }
    while (rects.size() < n) {
        rects.push_back(rects.back());
    }
    println(rects.size());
    for (auto &rect : rects) {
        if (rnd.next(2)) swap(rect.first, rect.second);
        println(rect.first, rect.second);
    }

}